# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CustomerInsights::Mgmt::V2017_04_26
  module Models
    #
    # The prediction model status.
    #
    class PredictionModelStatus

      include MsRestAzure

      # @return [String] The hub name.
      attr_accessor :tenant_id

      # @return [String] The prediction name.
      attr_accessor :prediction_name

      # @return [String] The prediction GUID ID.
      attr_accessor :prediction_guid_id

      # @return [PredictionModelLifeCycle] Prediction model life cycle.  When
      # prediction is in PendingModelConfirmation status, it is allowed to
      # update the status to PendingFeaturing or Active through API. Possible
      # values include: 'New', 'Provisioning', 'ProvisioningFailed',
      # 'PendingDiscovering', 'Discovering', 'PendingFeaturing', 'Featuring',
      # 'FeaturingFailed', 'PendingTraining', 'Training', 'TrainingFailed',
      # 'Evaluating', 'EvaluatingFailed', 'PendingModelConfirmation', 'Active',
      # 'Deleted', 'HumanIntervention', 'Failed'
      attr_accessor :status

      # @return [String] The model status message.
      attr_accessor :message

      # @return [Integer] Count of the training set.
      attr_accessor :training_set_count

      # @return [Integer] Count of the test set.
      attr_accessor :test_set_count

      # @return [Integer] Count of the validation set.
      attr_accessor :validation_set_count

      # @return [Integer] The training accuracy.
      attr_accessor :training_accuracy

      # @return [Integer] The singnas used.
      attr_accessor :signals_used

      # @return [String] Version of the model.
      attr_accessor :model_version


      #
      # Mapper for PredictionModelStatus class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PredictionModelStatus',
          type: {
            name: 'Composite',
            class_name: 'PredictionModelStatus',
            model_properties: {
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              },
              prediction_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'predictionName',
                type: {
                  name: 'String'
                }
              },
              prediction_guid_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'predictionGuidId',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              message: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'message',
                type: {
                  name: 'String'
                }
              },
              training_set_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'trainingSetCount',
                type: {
                  name: 'Number'
                }
              },
              test_set_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'testSetCount',
                type: {
                  name: 'Number'
                }
              },
              validation_set_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'validationSetCount',
                type: {
                  name: 'Number'
                }
              },
              training_accuracy: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'trainingAccuracy',
                type: {
                  name: 'Number'
                }
              },
              signals_used: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'signalsUsed',
                type: {
                  name: 'Number'
                }
              },
              model_version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'modelVersion',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
